
#include <stdio.h>
#include <stdlib.h>

extern void	Unit();

static FILE	*file;
static void	(*PutF)();

static void	PutN(ptr)
unsigned char	*ptr;
{
	(void)fwrite((void *)ptr,(size_t)4,(size_t)1,file);
}

#define PUTC(data)	(void)fputc((int)(data),file)

static void	PutR(ptr)
unsigned char	*ptr;
{
	PUTC(ptr[3]); PUTC(ptr[2]); PUTC(ptr[1]); PUTC(ptr[0]);
}

#define PUTB(data)	PUTC((data)&0xff)

void		Open(path,facets)
char		*path;
unsigned	facets;
{
	int	count;

	if (*path=='-')
	    file=stdout;
	else
	    if ((file=fopen(path,"wb"))==NULL) {
		(void)fprintf(stderr,"%s : STL file not stored.\n",path);
		exit(1);
	    }

	for (count=80; count>0; count--) PUTC(0);

	PUTB(facets); PUTB(facets>>8); PUTB(facets>>16); PUTB(facets>>24);
{
	short	word=0x1234;
	char	*byte=(char *)&word;

	PutF=(*byte==(word&0xff))?PutN:PutR;
}}

void	Store(x0,y0,z0,x1,y1,z1,x2,y2,z2,flag)
double	x0,y0,z0,x1,y1,z1,x2,y2,z2;
int	flag;
{
	double	nx,ny,nz,x10=x1-x0,y10=y1-y0,z10=z1-z0,
			 x20=x2-x0,y20=y2-y0,z20=z2-z0;

	Unit(y10*z20-z10*y20,z10*x20-x10*z20,x10*y20-y10*x20,&nx,&ny,&nz);
{
	float	tmp;

#define PUTF(data)	tmp=(float)(data); (*PutF)((unsigned char *)&tmp)

	PUTF(nx); PUTF(ny); PUTF(nz);
	PUTF(x0); PUTF(y0); PUTF(z0);
	PUTF(x1); PUTF(y1); PUTF(z1);
	PUTF(x2); PUTF(y2); PUTF(z2);
}
	PUTB(flag); PUTB(flag>>8);
}

void	Close()
{
	if (file!=stdout) (void)fclose(file);
}
