
#include <stdio.h>
#include <stdlib.h>

static FILE	*file;
static void	(*PutF)();

static void	PutN(ptr)
unsigned char	*ptr;
{
	(void)fwrite((void *)ptr,(size_t)4,(size_t)1,file);
}

#define PUTC(data)	(void)fputc((int)(data),file)

static void	PutR(ptr)
unsigned char	*ptr;
{
	PUTC(ptr[3]); PUTC(ptr[2]); PUTC(ptr[1]); PUTC(ptr[0]);
}

#define PUTB(data)	PUTC((data)&0xff)

void		Open(path,vertices,faces)
char		*path;
unsigned	vertices,faces;
{
	if (*path=='-')
	    file=stdout;
	else
	    if ((file=fopen(path,"wb"))==NULL) {
		(void)fprintf(stderr,"%s : ZCP file not stored.\n",path);
		exit(1);
	    }

	(void)fprintf(file,"ply\n"
			   "format binary_little_endian 1.0\n"
			   "element vertex %u\n"
			   "property float x\n"
			   "property float y\n"
			   "property float z\n"
			   "element face %u\n"
			   "property uchar red\n"
			   "property uchar green\n"
			   "property uchar blue\n"
			   "property list uchar int vertex_indices\n"
			   "end_header\n",
			   vertices,faces);
{
	short	word=0x1234;
	char	*byte=(char *)&word;

	PutF=(*byte==(word&0xff))?PutN:PutR;
}}

void	StoreVertex(x,y,z)
double	x,y,z;
{
	float	tmp;

#define PUTF(data)	tmp=(float)(data); (*PutF)((unsigned char *)&tmp)

	PUTF(x); PUTF(y); PUTF(z);
}

#define PUTL(data)	\
	PUTB(data); PUTB((data)>>8); PUTB((data)>>16); PUTB((data)>>24)

void		StoreFace(r,g,b,i,j,k)
int		r,g,b;
unsigned	i,j,k;
{
	PUTB(r); PUTB(g); PUTB(b); PUTC(3); PUTL(i); PUTL(j); PUTL(k);
}

void	Close()
{
	if (file!=stdout) (void)fclose(file);
}
